SystemOrganization addCategory: #'GMF-Generator'!
SystemOrganization addCategory: #'GMF-Generator-Tests'!

Object subclass: #CodeGenerator
	instanceVariableNames: ''
	classVariableNames: 'arguments class data index method methods parent temp temp2 variables'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 23:29'!
createAdditionalMethods
	self createSettersGetters.
	self createInitialize.
	self createNew.! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 4/8/2013 12:59'!
createClass
	| parent |
	class parent isNil ifTrue:[parent := 'Object'] ifFalse:[parent := class parent name].
	self class evaluatorClass
		evaluate:
			parent , ' subclass: #' , class name,'
		instanceVariableNames: ''' , temp,'''
		classVariableNames: ''' , temp2,'''
		poolDictionaries: ''''
		category: ''generatedClasses'''.
	class wasGenerated.! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/17/2013 16:45'!
createCollections
	| vars |
	vars := variables select:[:v | v collection notNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':=', v collection, ' new', '.
		' ])! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 23:09'!
createDefaultValues
	^''.! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 23:30'!
createInitialize
	self class evaluatorClass evaluate: '' , class name , ' compile: ''initialize ', '
	' , self createCollections, ' 
	', self createDefaultValues, '
	', self createNulls , '
	 '' classified: ''initialize-release'' '.! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/13/2013 00:33'!
createMethod
	self readMethodArguments.
	method isInstance ifTrue: [self class evaluatorClass
		evaluate: 
		'', class name, ' compile: ''', method name , self getStringArguments, (method isAbstract ifTrue:['
			^ self subclassResponsibility'] ifFalse:[' ']),' '' ' ]
	ifFalse: [ self class evaluatorClass
		evaluate: 
		'', class name, ' class compile: ''', method name , self getStringArguments, (method isAbstract ifTrue:['
			^ self subclassResponsibility'] ifFalse:[' ']), ' '' ' ]! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 21:12'!
createMethods
	methods size == 0 ifFalse:
		[ methods do:[:m | method := m. self createMethod. ]].
	self createAdditionalMethods.! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 23:30'!
createNew

	self class evaluatorClass evaluate:  '', class name, ' class compile: ''new ','
	^ super new
		initialize;
		yourself'' classified: ''instance creation'' '.! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 23:09'!
createNulls
	| vars |
	vars := variables select:[:v | v collection isNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':= nil.
		' ])! !

!CodeGenerator class methodsFor: 'private-create' stamp: 'RostislavNovk 5/10/2013 23:29'!
createSettersGetters
	variables
		do: [ :v | 
			self class evaluatorClass evaluate: '' , class name , ' compile: ''' , v name , '
			^' , v name , ' '' classified: ''accessing'' '.
			self class evaluatorClass evaluate: '' , class name , ' compile: ''' , v name ,': xVal
			' , v name , ':= xVal'' classified: ''accessing'' ' ]! !

!CodeGenerator class methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 10:48'!
generateCode: interface
	self readData: interface.
	index := 0.
	self isGenerated whileFalse: [ 
		self readNextClass.
		self readVariables.
		self createClass.
		self readMethods.
		self createMethods.  ]! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 5/13/2013 00:09'!
getStringArguments
	^(arguments inject: '' into:[:str :a | str,  a name, ': x', a name, ' '  ])! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:58'!
getStringVariables: xCollection
	| str |
	str := ''.
	xCollection size == 0
		ifFalse: [ xCollection do: [ :v | str := str, ' ' , v name ] ].
	^ str! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/8/2013 12:59'!
isGenerated
	^data classes allSatisfy: [:c | c isGenerated ].! !

!CodeGenerator class methodsFor: 'private-read' stamp: 'RostislavNovk 4/5/2013 14:16'!
readData: interface  
	data:= interface asGeneratorData.! !

!CodeGenerator class methodsFor: 'private-read' stamp: 'RostislavNovk 5/13/2013 00:00'!
readMethodArguments
	arguments := method arguments.! !

!CodeGenerator class methodsFor: 'private-read' stamp: 'RostislavNovk 4/5/2013 14:18'!
readMethods
	methods:= class methods.! !

!CodeGenerator class methodsFor: 'private-read' stamp: 'RostislavNovk 4/8/2013 12:07'!
readNextClass
	class := data classes detect: [ :c | c isGenerated not ].
		"Transcript show: 'Pred ' , class name; cr."
	[ 
	class parent notNil
		and:
			(class parent isNil
				ifTrue: [ false ]
				ifFalse: [ class parent isGenerated == false ]) ] whileTrue: [ class := class parent ]
		"Transcript show: 'Potom ' , class name; cr"! !

!CodeGenerator class methodsFor: 'private-read' stamp: 'RostislavNovk 4/8/2013 12:12'!
readVariables
	variables := class variables.
	temp := self getStringVariables: (variables select: [ :v | v isInstance ]).
	temp2 := self getStringVariables: (variables select: [ :v | v isClass ])! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 17:56'!
setData: xData
	data := xData.! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 12:16'!
setDataWithAll: xData
	data := xData.
	[self isGenerated] whileFalse: [
		self readNextClass.
		self readVariables.
		self createClass.
		self readMethods.
		self createMethods. ]! !

Object subclass: #GeneratedAll
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAll class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 10:32'!
new
	^ super new
		initialize;
		yourself! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 10:31'!
addClass: aGeneratedClass
	"adding classes"

	classes add: aGeneratedClass.! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:48'!
classes
	^ classes copy! !

!GeneratedAll methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 10:25'!
initialize
	"set numbers of used classes and relations to empty"

	classes := OrderedCollection new.
	^ self! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/7/2013 23:30'!
removeClass: aGeneratedClass
	"remove  classes"

	classes := classes reject:[: c| c == aGeneratedClass.]! !

Object subclass: #GeneratedClass
	instanceVariableNames: 'name comment variables methods superClass generated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:43'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment Code: xCode
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		code: xCode;
		yourself! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addMethod: aGeneratedEOCMethod
	"add to sortedcollection"

	methods add: aGeneratedEOCMethod! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addVariable: aGeneratedEOCVariable
	"add to sortedcollection"

	variables add: aGeneratedEOCVariable! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
comment
	^comment.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:50'!
comment: xComment
	comment:= xComment.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/8/2013 00:26'!
initialize
	variables:= OrderedCollection new.
	methods:= OrderedCollection new.
	comment:=''.
	superClass:=nil.
	generated := false.
	! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 00:25'!
isGenerated
	^generated! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 11:07'!
isSubClass
	[ superClass isNil ]
		ifTrue: [ ^ false ]
		ifFalse: [ ^ true ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
methods
	^methods copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
name
	^name.! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:50'!
name: xName
	name:= xName.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
parent
	^superClass.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
parent: xGeneratedClass
	superClass:= xGeneratedClass .! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
variables
	^variables copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 00:26'!
wasGenerated
	generated := true.! !

Object subclass: #GeneratedElementOfClass
	instanceVariableNames: 'name instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

GeneratedElementOfClass subclass: #GeneratedEOCMethod
	instanceVariableNames: 'code arguments abstract'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:28'!
newName: xName
	^ (super newName: xName)
		initialize;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Abstract: xAbstract
	^ (super newName: xName)
		initialize;
		abstract: xAbstract;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Code: xCode
	^ (super newName: xName)
		initialize;
		code: xCode;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Instance: xInstance Abstract: xAbstract
	^ (super newName: xName Instance: xInstance)
		initialize;
		abstract: xAbstract;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/13/2013 00:29'!
newName: xName Instance: xInstance Code: xCode
	^ (super newName: xName Instance: xInstance)
		initialize;
		code: xCode;
		yourself! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:56'!
abstract: xAbstract
	abstract := xAbstract.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:28'!
addArgument: xGeneratedEOCVariable
	arguments add: xGeneratedEOCVariable! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
arguments
	^ arguments copy! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
code
	^ code! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:47'!
code: xCode 
	code := xCode.! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'RostislavNovk 5/13/2013 00:29'!
initialize
	abstract := false.
	instance := true.
	arguments:= OrderedCollection new.! !

!GeneratedEOCMethod methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 18:55'!
isAbstract
	^abstract! !

GeneratedElementOfClass subclass: #GeneratedEOCVariable
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection
	^collection! !

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection: xCollection
	collection := xCollection! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:45'!
newName: xName Instance: xInstance
	^ super new
		name: xName;
		instance: xInstance;
		yourself! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:01'!
initialize
	instance := true
! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:51'!
instance: xInstance
	instance:=xInstance.
! !

!GeneratedElementOfClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 18:01'!
isClass
	"returns opposite of isInstantce"

	^ instance = false! !

!GeneratedElementOfClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 17:59'!
isInstance
	^ instance! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:52'!
name
	^ name! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 13:51'!
name: xName
	name := xName.
! !

TestCase subclass: #TestCodeGenerator
	instanceVariableNames: 'gAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator-Tests'!

!TestCodeGenerator methodsFor: 'initialize-release' stamp: 'RostislavNovk 5/10/2013 22:42'!
setUp
| vLive mIsLive cBeing vBirthNumber vName vDateOfBirth vAnimals mAge cPerson cMan cWoman mEat mSound cAnimal cDog |
vLive := GeneratedEOCVariable newName: 'live'.
mIsLive := GeneratedEOCMethod  newName: 'isLive'.
cBeing := GeneratedClass newName:  'Being'.
cBeing addVariable: vLive.
cBeing addMethod: mIsLive.

vBirthNumber := GeneratedEOCVariable newName: 'birthNumber'.
vName := GeneratedEOCVariable newName: 'name'.
vDateOfBirth := GeneratedEOCVariable newName: 'dateOfBirth'.
vAnimals := GeneratedEOCVariable newName: 'animals'.
mAge := GeneratedEOCMethod  newName: 'age'.
cPerson := GeneratedClass newName: 'Person'.
cPerson parent: cBeing.
cPerson addVariable: vBirthNumber.
cPerson addVariable: vName.
cPerson addVariable: vDateOfBirth.
cPerson addVariable: vAnimals.
cPerson addMethod: mAge.

cMan := GeneratedClass newName: 'Man'.
cMan parent: cPerson.
cWoman := GeneratedClass newName: 'Woman'.
cWoman parent: cPerson.

mEat := GeneratedEOCMethod newName: 'eat' Abstract: true.
mEat addArgument: (GeneratedEOCVariable newName: 'food').
mSound := GeneratedEOCMethod newName: 'sound' Instance: false Abstract: true.
cAnimal := GeneratedClass newName: 'Animal'.
cAnimal addMethod: mEat.
cAnimal addMethod: mSound.
cAnimal parent: cBeing.

mEat := GeneratedEOCMethod newName: 'eat'.
mEat addArgument: (GeneratedEOCVariable newName: 'food').
mSound := GeneratedEOCMethod newName: 'sound' Instance: false.
cDog := GeneratedClass newName: 'Dog'.
cDog addMethod: mEat.
cDog addMethod: mSound.
cDog parent: cAnimal.

gAll := GeneratedAll new.
gAll addClass: cDog.
gAll addClass: cWoman.
gAll addClass: cMan.
gAll addClass: cAnimal.
gAll addClass: cPerson.
gAll addClass: cBeing.

CodeGenerator setDataWithAll: gAll.! !

!TestCodeGenerator methodsFor: 'running' stamp: 'RostislavNovk 5/10/2013 22:42'!
testGenerator
	CodeGenerator setDataWithAll: gAll.! !
